<?php

namespace App\Classes\Jobs;

use App\Classes\Modules\Bookings\Processors\ListBookingsJobProcessor;
use App\Classes\Modules\Jobs\DataTransferObjects\ListGenericJobObject;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use App\Models\JobResult;
use Illuminate\Support\Facades\Log;

class ListBookingsJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    public $timeout = 900;

    /** @var ListGenericJobObject */
    private $listGenericJobObject;

    private $jobId;

    /**
     * ListBookingsJob constructor.
     * @param ListGenericJobObject $listGenericJobObject
     */
    public function __construct(ListGenericJobObject $listGenericJobObject)
    {
        $this->listGenericJobObject = $listGenericJobObject;
    }

    public function handle()
    {
        $rawPayload = $this->job->payload();
        if(isset($rawPayload['data']['commandName'])){
            $this->listGenericJobObject->setJobCommandName($rawPayload['data']['commandName']);
        }

        if(isset($rawPayload['data']['command'])){
            $this->listGenericJobObject->setJobCommand($rawPayload['data']['command']);
        }

        $result = (App()->make(ListBookingsJobProcessor::class))->execute($this->listGenericJobObject);
    }

    public function getJobId(){
        return $this->job->getJobId();
    }
}
